



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>用python来分割图片</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">用python来分割图片</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-18 20:18:14 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>程序思路：</p>
<p>此次程序主要是利用PIL（Python Image Libraty)这库，来进行图片的处理。PIL是一个功能非常强大的python图像处理标准库，但由于PIL只支持python2.7。如今很多python程序员都使用python3.x，所以PIL在之前的基础上分离出来一个分支，另外创建一个Pillow库，以便支持python3.x, 本程序在使用之前确保已经安装了Pillow库。</p>
<p>程序首先把你要分隔的图像读取到一个变量中，然后我们定义了一个 fill_image() 方法，用来填充图像让原本大小不一的图像，重新变为一个长宽相同的正方形图像，方便之后处理。通过 fill_image() 方法，我们就会得到新的一张正方形图像。随后我们在利用 cut_image() 方法，把图像分隔成 9 张，因为微信朋友圈最多发 9张图片。</p>
<div>
<pre class="prettyprint linenums"> from PIL import Image<br />
 import sys

 #先将 input image 填充为正方形<br />
 def fill_image(image):<br />
     width, height = image.size<br />
     #选取长和宽中较大值作为新图片的<br />
     new_image_length = width if width &gt; height else height<br />
     #生成新图片[白底]<br />
     new_image = Image.new(image.mode, (new_image_length, new_image_length), color='white')   #注意这个函数！<br />
     #将之前的图粘贴在新图上，居中<br />
     if width &gt; height:#原图宽大于高，则填充图片的竖直维度  #(x,y)二元组表示粘贴上图相对下图的起始位置,是个坐标点。<br />
         new_image.paste(image, (0, int((new_image_length - height) / 2)))<br />
     else:<br />
         new_image.paste(image, (int((new_image_length - width) / 2),0))<br />
     return new_image

 def cut_image(image):<br />
     width, height = image.size<br />
     item_width = int(width / 3)  #因为朋友圈一行放3张图。<br />
     box_list = []<br />
     # (left, upper, right, lower)<br />
     for i in range(0,3):<br />
         for j in range(0,3):<br />
             #print((i*item_width,j*item_width,(i+1)*item_width,(j+1)*item_width))<br />
             box = (j*item_width,i*item_width,(j+1)*item_width,(i+1)*item_width)<br />
             box_list.append(box)<br />
     image_list = [image.crop(box) for box in box_list]<br />
     return image_list

 #保存<br />
 def save_images(image_list):<br />
     index = 1<br />
     for image in image_list:<br />
         image.save(str(index) + '.png', 'PNG')<br />
         index += 1

 if __name__ == '__main__':<br />
     file_path = "2.jpg"  #图片保存的地址<br />
     image = Image.open(file_path)<br />
     #image.show()<br />
     image_new = fill_image(image)<br />
     image_list = cut_image(image_new)<br />
     save_images(image_list)</pre>
</div>
<p>如果有兴趣的话可以看一看Pillow库的使用</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvew6j9.html">&amp;amp&semi;&num;65279&semi; 非法字符 原因 以及解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4k3me9.html">我是如何社工TDbank获取朋友隐私的</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyx3gg8.html">python小打小闹之简陋版BBS</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z72ld9.html">友善p35屏</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96ekgyq.html">&lbrack;原&rsqb;quick集成spine动画</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmeo2k9.html">Hibernate开始上手总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vdgw38.html">poj3295Tautology</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v30w48.html">JavaScript代码性能优化总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj52k69.html">less可以做什么？less详解！&lpar;less嵌套选择器实现纯CSS二级导航&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo4jk3q.html">Viewpager结合fragment实现底部导航</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg7z0d8.html">win7中python3&period;4下安装scrapy爬虫框架（亲测可用）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvdzr38.html">admin-2</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw7x1y8.html">阶段01Java基础day24多线程&plus;GUI</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyzzwdq.html">maven 插件深入了解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7eo7ze9.html">转 Linux定时执行任务命令at和crontab</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlv2vz9.html">hdu-2045 递归</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql156ge9.html">SQL Server存储过程 对数组参数的循环处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/953zzy68.html">oracle exp dmp</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p63e5q.html">51nod1019 逆序数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdj1670q.html">Unity3D 笔记一 初始Unity3D</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnvp67x8.html">jmeter本机内存溢出如何修改？</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r1xo58.html">inno setup  软件打包</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd7gpz9.html">《机器学习实战》KNN算法实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv3gzz8.html">uva-10718-贪心</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5vvkeq.html">spark sql运行原理</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1556e9.html">14&period; js字符串截取substring用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5vvldq.html">1&period; ip正则表达式验证</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25po3xq.html">canal 入门（基于docker）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwl0078.html">4&period;高级js--&lpar;面向对象js&rpar;&lowbar;2</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwl1j78.html">centos查看命令</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
